首页
学习
活动
专区
圈层
工具
发布
社区首页 >专栏 >完全背包

完全背包

作者头像
SakuraTears
发布于 2022-01-13 14:58:22
发布于 2022-01-13 14:58:22
5040
举报

题目

思路

和01背包思路差不多,01背包是只能选一个,完全背包是可以选无数个直到占满背包。 所以要把每个物品都枚举k次,直到超出背包重量。

在01背包上改动一些即可(超时)

代码语言:javascript
复制
#include <iostream>
#include <vector>
 
using namespace std;
 
int main()
{
    int n, m, res = 0;
    vector<vector<int>> dp = vector<vector<int>>(1010, vector<int>(1010, 0));
    vector<int> v = vector<int>(1010, 0);
    vector<int> w = vector<int>(1010, 0);
    cin>>n >> m;
    for (int i = 1; i <= n; i++)
    {
        cin>>v[i] >>w[i];
    }
    for (int i = 1; i <= n; i++)
    {
        for (int j = 0; j <= m; j++)
        {
            for (int k = 0; k * v[i] <= j; k++)
            {
                dp[i][j] = max(dp[i][j], dp[i - 1][j - k * v[i]] + k * w[i]);
            }
        }
    }
    cout<<dp[n][m]<<endl;
    return 0;
}

优化

f[i , j ] = max( f[i-1,j] , f[i-1,j-v]+w , f[i-1,j-2v]+2w , f[i-1,j-3v]+3w , .....) f[i , j-v]= max( f[i-1,j-v] , f[i-1,j-2v] + w , f[i-1,j-2v]+2*w , .....) 由上两式,可得出如下递推关系: fi=max(f[i,j-v]+w , fi-1)

有了这个递推上面的k次循环就可以写成这个递推 然后双循环:

代码语言:javascript
复制
for (int i = 1; i <= n; i++)
{
    for (int j = 0; j <= m; j++)
    {
        dp[i][j] = dp[i][j - 1];
        if (j >= v[i])
        {
            dp[i][j] = max(dp[i][j], f[i, j - v[i]] + w[i]);
        }
    }
}

这个代码和01背包非常相似 f[i][j] = max(f[i][j], f[i - 1][j - v[i]] + w[i]); 01背包

f[i][j] = max(f[i][j], f[i][j - v[i]] + w[i]);完全背包

然后参考01背包的优化,完全背包也可以优化:

代码语言:javascript
复制
for(int i = 1 ; i <= n ;i++)
{
    for(int j = v[i] ; j <= m ;j++)
    {
        f[j] = max(f[j], f[j - v[i]] + w[i]);
    }
}

这里可以看到完全背包的遍历是正着遍历的,因为这里的递推不是由i - 1递推上来的,所以可以正着遍历

完整代码:

代码语言:javascript
复制
#include <iostream>
#include <vector>

using namespace std;

int main()
{
    int n, m;
    vector<int> dp = vector<int>(1010, 0);
    vector<int> v = vector<int>(1010, 0);
    vector<int> w = vector<int>(1010, 0);
    cin >> n >> m;
    for (int i = 1; i <= n; i++)
    {
        cin >> v[i] >> w[i];
    }
    for (int i = 1; i <= n; i++)
    {
        for (int j = v[i]; j <= m; j++)
        {
            dp[j] = max(dp[j], dp[j - v[i]] + w[i]);
        }
    }
    cout << dp[m] << endl;
    return 0;
}

思路参考: 作者:Aniway 链接:https://www.acwing.com/solution/content/5345/ 来源:AcWing 著作权归作者所有。商业转载请联系作者获得授权,非商业转载请注明出处。

本文参与 腾讯云自媒体同步曝光计划,分享自作者个人站点/博客。
原始发表:2021年05月14日,如有侵权请联系 cloudcommunity@tencent.com 删除
目录
  • 题目
  • 思路
  • 优化
问题归档专栏文章快讯文章归档关键词归档开发者手册归档开发者手册 Section 归档